From e3b39820d12b89e926d9542216c3a7454164af91 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 02 2020 02:09:25 +0000
Subject: [PATCH 1193/2232] Recognize identical block being closed and opened


---

diff --git a/gen/src/out.rs b/gen/src/out.rs
index 0f12e89..2733c32 100644
--- a/gen/src/out.rs
+++ b/gen/src/out.rs
@@ -18,11 +18,17 @@ pub(crate) struct OutFile<'a> {
 #[derive(Default)]
 pub struct Content<'a> {
     bytes: String,
-    blocks: Vec<Block<'a>>,
+    blocks: Vec<BlockBoundary<'a>>,
     section_pending: bool,
     blocks_pending: usize,
 }
 
+#[derive(Copy, Clone, PartialEq, Debug)]
+enum BlockBoundary<'a> {
+    Begin(Block<'a>),
+    End(Block<'a>),
+}
+
 impl<'a> OutFile<'a> {
     pub fn new(header: bool, opt: &'a Opt, types: &'a Types) -> Self {
         OutFile {
@@ -53,10 +59,11 @@ impl<'a> OutFile<'a> {
         Write::write_fmt(content, args).unwrap();
     }
 
-    pub fn content(&self) -> Vec<u8> {
+    pub fn content(&mut self) -> Vec<u8> {
+        self.flush();
         let include = &self.include.content.bytes;
         let builtin = &self.builtin.content.bytes;
-        let content = &self.content.borrow().bytes;
+        let content = &self.content.get_mut().bytes;
         let len = include.len() + builtin.len() + content.len() + 2;
         let mut out = String::with_capacity(len);
         out.push_str(include);
@@ -73,6 +80,12 @@ impl<'a> OutFile<'a> {
         }
         out.into_bytes()
     }
+
+    fn flush(&mut self) {
+        self.include.content.flush();
+        self.builtin.content.flush();
+        self.content.get_mut().flush();
+    }
 }
 
 impl<'a> Write for Content<'a> {
@@ -98,21 +111,11 @@ impl<'a> Content<'a> {
     }
 
     pub fn begin_block(&mut self, block: Block<'a>) {
-        self.blocks.push(block);
-        self.blocks_pending += 1;
+        self.push_block_boundary(BlockBoundary::Begin(block));
     }
 
     pub fn end_block(&mut self, block: Block<'a>) {
-        let begin_block = self.blocks.pop().unwrap();
-        let end_block = block;
-        assert_eq!(begin_block, end_block);
-
-        if self.blocks_pending > 0 {
-            self.blocks_pending -= 1;
-        } else {
-            Block::write_end(block, &mut self.bytes);
-            self.section_pending = true;
-        }
+        self.push_block_boundary(BlockBoundary::End(block));
     }
 
     pub fn write_fmt(&mut self, args: Arguments) {
@@ -122,14 +125,9 @@ impl<'a> Content<'a> {
     fn write(&mut self, b: &str) {
         if !b.is_empty() {
             if self.blocks_pending > 0 {
-                if !self.bytes.is_empty() {
-                    self.bytes.push('\n');
-                }
-                let pending = self.blocks.len() - self.blocks_pending..;
-                for block in &self.blocks[pending] {
-                    Block::write_begin(*block, &mut self.bytes);
-                }
-            } else if self.section_pending && !self.bytes.is_empty() {
+                self.flush_blocks();
+            }
+            if self.section_pending && !self.bytes.is_empty() {
                 self.bytes.push('\n');
             }
             self.bytes.push_str(b);
@@ -137,4 +135,59 @@ impl<'a> Content<'a> {
             self.blocks_pending = 0;
         }
     }
+
+    fn push_block_boundary(&mut self, boundary: BlockBoundary<'a>) {
+        if self.blocks_pending > 0 && boundary == self.blocks.last().unwrap().rev() {
+            self.blocks.pop();
+            self.blocks_pending -= 1;
+        } else {
+            self.blocks.push(boundary);
+            self.blocks_pending += 1;
+        }
+    }
+
+    fn flush(&mut self) {
+        if self.blocks_pending > 0 {
+            self.flush_blocks();
+        }
+    }
+
+    fn flush_blocks(&mut self) {
+        self.section_pending = !self.bytes.is_empty();
+        let mut read = self.blocks.len() - self.blocks_pending;
+        let mut write = read;
+
+        while read < self.blocks.len() {
+            match self.blocks[read] {
+                BlockBoundary::Begin(begin_block) => {
+                    if self.section_pending {
+                        self.bytes.push('\n');
+                        self.section_pending = false;
+                    }
+                    Block::write_begin(begin_block, &mut self.bytes);
+                    self.blocks[write] = BlockBoundary::Begin(begin_block);
+                    write += 1;
+                }
+                BlockBoundary::End(end_block) => {
+                    write = write.checked_sub(1).unwrap();
+                    let begin_block = self.blocks[write];
+                    assert_eq!(begin_block, BlockBoundary::Begin(end_block));
+                    Block::write_end(end_block, &mut self.bytes);
+                    self.section_pending = true;
+                }
+            }
+            read += 1;
+        }
+
+        self.blocks.truncate(write);
+    }
+}
+
+impl<'a> BlockBoundary<'a> {
+    fn rev(self) -> BlockBoundary<'a> {
+        match self {
+            BlockBoundary::Begin(block) => BlockBoundary::End(block),
+            BlockBoundary::End(block) => BlockBoundary::Begin(block),
+        }
+    }
 }

